
#define INCLUDED_RPC_RPC_H  /* Cludge: prevents inclusion of `rpc/rpc.h' by
                                       `p4.h', which introduces some clashes */
                            /* Thought: try putting `p4' after `javaString' */
#include "p4.h"

#include "SendBuffer.h"
#include "RecvBuffer.h"
#include "P4.h"
#include "javaString.h"

void P4_initEnv(struct HP4 *this, HArrayOfString *args) {
  int i, result, len = obj_length(args) + 1 ;
  HString **data = unhand(args)->body ;

  char **sargs = (char**)calloc(len + 1, sizeof(char*)) ; 
  int locId ;

  void (*javaDisp)(int) ;

  sargs [0] = "java" ;  /* Cludge: Java doesn't give the executable name.
                                   Makes default procgroup file `java.pg' */
  for (i=1; i<len; i++)
    sargs [i] = allocCString(data [i - 1]);

  
  /*
  javaDisp = signal(SIGALRM,SIG_DFL) ;
debug */
  p4_initenv(&len, sargs);
  /* 
  signal(SIGALRM,javaDisp) ;
debug */
}

void P4_waitForEnd(struct HP4 *this) {
  p4_wait_for_end() ;
}

void P4_createProcGroup(struct HP4 *this) {
  p4_create_procgroup() ;
}

long P4_getMyId(struct HP4 *this) {
  return p4_get_my_id() ;
}

long P4_numTotalIds(struct HP4 *this) {
  return p4_num_total_ids() ;
}


void P4_send(struct HP4 *this, long type, long to, struct HSendBuffer *msg) {
  void* dataHandle = *((void**) &(unhand(msg)->dataHandle)) ;
  
  p4_send(type, to, (char*) dataHandle, unhand(msg)->msgLen) ;
}

void P4_recv(struct HP4 *this, long _type, long _from,
             struct HRecvBuffer *msg) {

  char* buffHandle = *((char**) &(unhand(msg)->buffHandle)) ;
  void* dataHandle = *((void**) &(unhand(msg)->dataHandle)) ;
  int len, type = _type, from = _from ;

  p4_recv(&type, &from, &buffHandle, &len) ;

  memcpy((char*) dataHandle, buffHandle, len) ;
      /* Copying unavoidable, because Java can't manipulate data it doesn't
         allocate, and p4 can't recv into memory *it* doesn't allocate.  */

  unhand(msg)->msgType = type ;
  unhand(msg)->msgFrom = from ;
  unhand(msg)->msgLen  = len  ;
}

void P4_initIntSendBuffer(struct HP4 *this, struct HSendBuffer *msg,
                          HArrayOfInt *data) {
  int len = sizeof(int) * obj_length(data) ;
  void** dataHandle = (void**) &(unhand(msg)->dataHandle) ;

  *dataHandle = (void*) unhand(data)->body ;
  unhand(msg)->msgLen = len ;
}

void P4_initIntRecvBuffer(struct HP4 *this, struct HRecvBuffer *msg,
                          HArrayOfInt *data) {
  int len = sizeof(int) * obj_length(data) ;
  void** dataHandle = (void**) &(unhand(msg)->dataHandle) ;
  char** buffHandle = (char**) &(unhand(msg)->buffHandle) ;

  *dataHandle = (void*) unhand(data)->body ;
  *buffHandle = p4_msg_alloc(sizeof(int) * len) ;
}

void P4_destroyRecvBuffer(struct HP4 *this, struct HRecvBuffer *msg) {
  char* buffHandle = *((char**) &(unhand(msg)->buffHandle)) ;

  p4_msg_free(buffHandle) ;
}

